;-------------------------------------------------------------------------------
.686
.mmx
.model flat,STDCALL
;-------------------------------------------------------------------------------
.data
include motore.inc
include posizioni.inc
include debug.inc
include dati.inc
include valuta.inc
;-------------------------------------------------------------------------------
.code
;-------------------------------------------------------------------------------
DEBUG_MOSSA_0 macro
  if 1
    cmp [esi.nLivello], 0
    jne ag_assegna2
    ACAPO
    PUTCHAR '^'
  	call DebugMossa
    ACAPO
   ag_assegna2:
  endif
endm
;-------------------------------------------------------------------------------
TICKMOSSA_0 macro
  if 1
    cmp [esi.nLivello], 0
    jne ag_esegui2
    PUTCHAR ' '   ; CR
  	call DebugMossa
    ag_esegui2:
  endif
endm
;-------------------------------------------------------------------------------
PushPosition proc
	; salva la posizione corrente nella TT
  ; eax: valore posizione
	; esi: nodo
  ; mm3: chiave della posizione
  ; usa ecx senza salvarlo
  mov ebx, [esi.nHashIndex]
  test ebx, ebx
  je ag_noindex
  if DEBUG_ALFAGEMMA
    call DebugMossa
    PUTCHARS ' ', '+', 'H', '='
    push eax
    mov eax, ebx
    call DebugHex
    PUTCHAR '('
    movd eax, mm3
    call DebugHex
    PUTCHAR ')'
    pop eax
    PUTCHARS ' ', 'V', '='
    call DebugHex
  endif
  mov ecx, [_ret_vals.rLivAttuale]
  movq [ebx.hKey], mm3
  sub ecx, [esi.nLivello]
  mov [ebx.hValue], eax
  mov [ebx.hPly], cx
  mov [ebx.hType], 0
ag_noindex:
	ret
endp
;-------------------------------------------------------------------------------
_inizializza_alfagemma proc
	pushad

  mov eax, _ret_vals.rTTableSize				; calcola la maschera per l'hashing della transposition table
  dec eax																; deve essere una potenza di due (es: 100000000000b => 11111111111b)
  shr eax, SIZEHASH2										; toglie i bit corrispondenti alla dimensione di un'entry nella ttable
  shl eax, SIZEHASH2										; li rimette a zero (es: 11111111111b => 1111111b => 11111110000b)
  mov _ret_vals.rTTableMask, eax

  mov _ret_vals.rLivAttuale, 2

	call SetPos
  call DebugCase
  ACAPO

	popad
  emms
  ret
endp
;-------------------------------------------------------------------------------
_alfagemma proc
	pushad
	call _inizializza_alfagemma
  mov esi, offset nodi
  xor ebp, ebp

  if DEBUG_ALFAGEMMA
	  PRINT sAlfaGemma
	  call DebugCase
  endif

	jmp ag_ciclonodi

ag_prossimo_livello:
	if DEBUG_ALFAGEMMA
  	inc [esi.nLivello]
  	PRINT sScendo, [esi.nLivello]
  	dec [esi.nLivello]
  endif
  neg ebp
  mov [esi.nValIniziale+size Nodo], ebp ; salva il valore iniziale del nodo
  lea esi, [esi+size Nodo]  						; prossimo nodo
ag_ciclonodi:
  mov eax, [esi.nValRamo-2*size Nodo]   ; carica il valore di due nodi precedenti
  if CONTA_MOSSE
  	add _ret_vals.rNumNodiL, 1
    adc _ret_vals.rNumNodiH, 0
    test _ret_vals.rNumNodiL, 0fffffh
    jne ag_notick
    PUTCHAR '.'
    if ITERATIVE_PRUDENTE
    	nop
    else
      pushad
      call _SysElapsed
      cmp eax, _ret_vals.rMaxTime
      popad
      jl ag_notick
      mov _ret_vals.rStop, 1
      jmp ag_taglia
    endif
ag_notick:
  endif

  cmp _ret_vals.rStop, 1
  je ag_forza_chiusura

  mov [esi.nValRamo], eax
  mov [esi.nMigliore], 0
	if USA_ZOBRIST
	  movq [esi.nKey], mm5                ; salva la zobrist key attuale
  endif
	call GeneraMosse

ag_ciclo_iterative:
  xor eax, eax
	mov edx, [esi.nMosse]
  mov [esi.nValRamo], MINIMO
  mov [esi.nMigliore], eax
	mov [esi.nEseguita], eax
  jmp ag_cerca
ag_matto:
	if DEBUG_ALFAGEMMA
  	PRINT sIllegale
	endif
	mov edx, [esi.nEseguita]   						; carica la mossa eseguita
	call AnnullaMossa
  mov [edx.mValRamo], MINIMO						; non giocher pi questa mossa illegale
	TESTMOSSE
ag_cerca:
	call CercaMiglioreFast
  je ag_finite
ag_esegui:
	call EseguiMossa
 	call TestScacco
  jnp ag_matto													; mossa illegale perch lascia il RE sotto scacco

  TICKMOSSA_0

  add [esi.nNumValideL], 1
  adc [esi.nNumValideH], 0
 	if CONTA_MOSSE
		add _ret_vals.rNumMosseL, 1
		adc _ret_vals.rNumMosseH, 0
  endif
;--------------------------------------- cerca nella Transposition Table
  if USA_ZOBRIST
    movd ebx, mm5												; ebx = key della posizione dopo la mossa
    and ebx, [_ret_vals.rTTableMask]		; maschera ebx per ottenere l'indice alla ttable
    add ebx, [_ret_vals.rTTable]				; indice finale della ttable
  	mov [esi.nHashIndex], ebx						; salva l'indice alla ttable, per non ricalcolarlo

    mov ecx, [_ret_vals.rLivAttuale]    ; TODO: salvare per ogni livello
    sub ecx, [esi.nLivello]             ; il numeor di livelli mancanti a fine albero
    cmp cx, [ebx.hPly]
    jg ag_nohash

    movq mm3, mm5												; mm3 = key della posizione
    pcmpeqd mm3, [ebx.hKey]							; confronta con la key dell'entry della ttable
    movd ecx, mm3												; risultato del confronto: parte bassa
    test ecx, ecx
    je ag_nohash												; non corrisponde
    psrlq mm3, 32
    movd ecx, mm3												; risultato del confronto, parte alta
    test ecx, ecx
    je ag_nohash												; non corrisponde
ag_hash_found:
		if DEBUG_ALFAGEMMA
    	PUTCHARS ' ', 'H', 'F', '!', ' '
    endif
    if 1
	    mov eax, [ebx.hValue]
  	  inc [_ret_vals.rNumTTL]
    	jnc ag_annulla
	    inc [_ret_vals.rNumTTH]
  	  jmp ag_annulla
    endif
ag_nohash:
  endif
;---------------------------------------

ag_next:
 	cmp esi, _ret_vals.rLivelloP
  jl ag_prossimo_livello
ag_ultimonodo:
  call Valuta                           ; valuta la posizione finale
  jmp ag_annulla

ag_risali_stallo:
  if DEBUG_ALFAGEMMA
  	PRINT sStallo, [esi.nLivello]
  endif
ag_risali:
	neg eax                               ; inverte il valore finale della posizione
ag_risali_no_neg:
	TESTMOSSE
	cmp esi, offset nodi                  ; siamo al primo nodo?
	je ag_fine
	lea esi, [esi-size Nodo]							; torna al nodo precedente
  if DEBUG_ALFAGEMMA
  	PRINT sRisalgo, [esi.nLivello]
  endif
ag_annulla:
  push eax															; eax = valore ramo
  movq mm3, mm5													; salva la chiave della mossa eseguita
	mov edx, [esi.nEseguita]   						; carica la mossa eseguita
 	call AnnullaMossa
	TESTMOSSE
  pop eax
;--------------------------------------- salva nella Transposition Table
  if USA_ZOBRIST
  	cmp eax, VAL_MINIMO
    je ag_z_notsave
  	call PushPosition
    ag_z_notsave:
  endif
;---------------------------------------
  mov [edx.mValRamo], eax								; salva il valore del ramo nella mossa (per iterative deepening)
  cmp eax, [esi.nValRamo]               ; eax = valore ramo del nodo attuale

ag_assegna:
  jle ag_cerca

	DEBUG_MOSSA_0

  if DEBUG_ALFAGEMMA
  	PRINT sAssegno, [esi.nLivello]
    call DebugMossa
  endif

  mov [esi.nValRamo], eax               ; valore del ramo nel nodo
  mov [esi.nMigliore], edx              ; migliore mossa del ramo
	TESTMOSSE

  cmp eax, F_VAL_MATTO
	je ag_finite

ag_test:
	neg eax
  cmp eax, [esi.nValRamo-size Nodo]
  jg ag_cerca
ag_taglia:
	if DEBUG_ALFAGEMMA
  	PRINT sTaglio, [esi.nLivello]
  endif
  if 0
	  mov eax, VAL_MINIMO
  else
  	mov eax, [esi.nValRamo-size Nodo]
    dec eax
  endif
  jmp ag_risali_no_neg

ag_forza_chiusura:
	PRINT sTimeOut
ag_forza_loop:
	cmp esi, offset nodi                  ; siamo al primo nodo?
	je ag_fine                            
  
	lea esi, [esi-size Nodo]
	mov edx, [esi.nEseguita]   						; carica la mossa eseguita
  call AnnullaMossa
	jmp ag_forza_loop

ag_finite:
	if DEBUG_ALFAGEMMA
  	PRINT sFinite, [esi.nLivello]
  endif
	mov eax, [esi.nValRamo]
	cmp [esi.nNumValideL], 0              ; teoricamente sarebbe da controllare anche nNumMosseValideH
  jne ag_risali
  xor eax, eax													; TODO: sostituire col valore dello stallo
  call TestScacco
  jp ag_risali_stallo										;  stallo
	mov eax, -F_VAL_MATTO
	if DEBUG_ALFAGEMMA
  	PRINT sMatto, [esi.nLivello]
  endif
  jmp ag_risali

ag_fine:
  test ebp, ebp
  je ag_okval
	;if DEBUG_ALFAGEMMA
  	nop
  	PRINT sErroreEbp, ebp
  ;endif
ag_okval:

ag_iterative_deepening:
  ACAPO
  ACAPO
  ;call DebugMosse
  mov ebp, MINIMO
  mov edx, [esi.nMosse]									; prima mossa del nodo
  mov ecx, [esi.nMosse + size Nodo]			; prima mossa del nodo seguente
ag_ciclo_assegna_val:
  mov eax, [edx.mValRamo]
  mov [edx.mValore], eax
  call DebugMossa
  cmp eax, ebp
  jle ag_nomax
  mov ebp, eax
  mov [esi.nMigliore], edx
  PUTCHARS '<','-','-','-'
ag_nomax:
  ACAPO
  lea edx, [edx + size Mossa]
  cmp edx, ecx
  jl ag_ciclo_assegna_val

	if 1
    ACAPO
    mov edx, [esi.nMigliore]
    call DebugMossa
  endif

ag_prossima_iterazione:
  xor ebp, ebp

	cmp _ret_vals.rStop, 1
  je ag_esci_incompleto

  if DEBUG_001
    mov eax, [esi.nMigliore]
    mov [esi.nMigliorePrev], eax
  endif

  mov ebx, 2                          ; delta iterative
  mov eax, _ret_vals.rLivAttuale
  add eax, ebx
  mov _ret_vals.rLivAttuale, eax			; livello massimo per questa iterazione

  imul ebx, size Nodo
  add _ret_vals.rLivelloP, ebx

  cmp eax, _ret_vals.rLivello
  jg ag_esci

  call _SysElapsed
  push eax
  mov ebx, eax
  mov eax, _ret_vals.rLivAttuale
  PRINT sIterazione, eax, ebx
  pop eax
  imul eax, 3 													; NB: si chiede se ha ancora il triplo del tempo utilizzato nell'iterazione attuale
  cmp eax, _ret_vals.rMaxTime
  if ITERATIVE_PRUDENTE
	  jl ag_ciclo_iterative
  else
	  jmp ag_ciclo_iterative
  endif
ag_esci_incompleto:
  ;call DebugMosse
  if DEBUG_001
    mov edx, [esi.nMigliorePrev]
    mov [esi.nMigliore], edx 
  endif
ag_esci:
	mov edx, [esi.nMigliore]
  test edx, edx
  jne ag_trovata
	call CercaMiglioreFast
ag_trovata:
	mov [esi.nMigliore], edx
ag_escimatto:
  call EseguiMossaColore

	popad
	ret
endp
;-------------------------------------------------------------------------------
end
