global _perfect: proc
global _inizializza_alfagemma: proc
global _alfagemma: proc
global _getmosse: proc
global _esegui: proc
global EseguiMossaColore: proc
global GeneraMosse: proc
global CercaMigliore: proc
global CercaMiglioreFast: proc
global EseguiMossa: proc
global TestScacco: proc
global AnnullaMossa: proc
global MuoviRe: proc
global MuoviTorre: proc
global MuoviCavallo: proc
global MuoviAlfiere: proc
global MuoviDonna: proc
global MuoviPedoneB: proc
global MuoviPedoneN: proc
;-------------------------------------------------------------------------------
; casa:                                                          bit 31...0
; _______________ --------------- _______________ ---------------
; 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
; f e d c b a 9 8 7 6 5 4 3 2 1 0 f e d c b a 9 8 7 6 5 4 3 2 1 0
; V [___________] [_____________] - - D d C c N B R r T t A a P p
; | |           | |             | | | | | | | | | | | | | | | | |
; | |           | |             | | | | | | | | | | | | | | | | \__ Pedone bianco
; | |           | |             | | | | | | | | | | | | | | | \____ Pedone nero
; | |           | |             | | | | | | | | | | | | | | \______ Alfiere bianco
; | |           | |             | | | | | | | | | | | | | \________ Alfiere nero
; | |           | |             | | | | | | | | | | | | \__________ Torre bianca
; | |           | |             | | | | | | | | | | | \____________ Torre nera
; | |           | |             | | | | | | | | | | \______________ Re bianco
; | |           | |             | | | | | | | | | \________________ Re nero
; | |           | |             | | | | | | | | \__________________ Bianco
; | |           | |             | | | | | | | \____________________ Nero
; | |           | |             | | | | | | \______________________ Cavallo bianco
; | |           | |             | | | | | \________________________ Cavallo nero
; | |           | |             | | | | \__________________________ Donna bianca
; | |           | |             | | | \____________________________ Donna nera
; | | val pezzo | |  val casa   | | \______________________________ libero
; | |           | |             | \________________________________ libero
; | |           | \_____________\__________________________________ valore della casa
; | |           |                                                   --- VALORE DEL PEZZO
; | \___________\__________________________________________________ valore del pezzo
; \________________________________________________________________ casa vuota
;
;-------------------------------------------------------------------------------
; Controllo dello scacco: (esempio per scacco al Re bianco su diagonale)
; si testano i flag del pezzo A oppure T (la Donna li ha entrambi settati)
; la prima casa viene testata anche per i flag del Re ed eventualmente del Pedone:
;
; test [flags], F_VUOTA+F_BIANCO+F_NERO+F_N_ALFIERE+F_N_DONNA+{F_N_RE+F_N_PEDONE}
; jnp SCACCO
; jge NEXTDIR
; ...casa vuota...
;-------------------------------------------------------------------------------
BIT_FLAGS        equ       1h 					; 1 byte: flags per il controllo dello scacco
BIT_FLAGS2       equ     100h 					; 2 byte: flags donna e cavallo
BIT_VALCASA      equ   10000h 					; 3 byte
BIT_VALPEZZO     equ 1000000h 					; 4 byte
;-------------------------------------------------------------------------------
F_B_PEDONE       equ 0000000000000001b
F_N_PEDONE       equ 0000000000000010b
F_B_ALFIERE      equ 0000000000000100b
F_N_ALFIERE      equ 0000000000001000b
F_B_TORRE        equ 0000000000010000b
F_N_TORRE        equ 0000000000100000b
F_B_RE           equ 0000000001000000b
F_N_RE           equ 0000000010000000b
F_BIANCO         equ 0000000100000000b
F_NERO           equ 0000001000000000b
F_B_CAVALLO      equ 0000010000000000b
F_N_CAVALLO      equ 0000100000000000b
F_B_DONNA        equ 0001000000000000b
F_N_DONNA        equ 0010000000000000b
F_X_FREE         equ 0100000000000000b
F_Y_FREE         equ 1000000000000000b

;-------------------------------------------------------------------------------
FEN_RE_N       	 equ 'k'
FEN_DONNA_N      equ 'q'
FEN_TORRE_N      equ 'r'
FEN_ALFIERE_N    equ 'b'
FEN_CAVALLO_N    equ 'n'
FEN_PEDONE_N     equ 'p'
;-------------------------------------------------------------------------------
FEN_RE_B         equ 'K'
FEN_DONNA_B      equ 'Q'
FEN_TORRE_B      equ 'R'
FEN_ALFIERE_B    equ 'B'
FEN_CAVALLO_B    equ 'N'
FEN_PEDONE_B     equ 'P'
;-------------------------------------------------------------------------------
F_VAL_RE         equ 01000000b
F_VAL_CERCA_M    equ 00800000b
F_VAL_DONNA      equ 00001010b
F_VAL_TORRE      equ 00000101b
F_VAL_ALFIERE    equ 00000011b
F_VAL_CAVALLO    equ 00000011b
F_VAL_PEDONE     equ 00000001b
;-------------------------------------------------------------------------------
F_VAL_VUOTA      equ 00000000b
F_VAL_MATTO      equ (BIT_VALPEZZO*F_VAL_RE)
F_VAL_ARROCCO    equ (BIT_VALPEZZO*F_VAL_PEDONE/2)
F_CERCA_MATTO    equ (0 + BIT_VALPEZZO*F_VAL_CERCA_M)
F_DELTA_MATTO    equ BIT_VALCASA
;-------------------------------------------------------------------------------
; valori per Mossa.mSpeciale
F_NO_SPECIALE		 equ 00000000b
F_ARROCCO_00     equ 00000010b
F_ARROCCO_000    equ 00000011b
F_ENPASSANT      equ 00000100b
F_SPINTADIDUE 	 equ 00000101b
;-------------------------------------------------------------------------------
F_RE_BIANCO      equ (F_BIANCO+F_B_RE       +(BIT_VALPEZZO*F_VAL_RE))
F_DONNA_BIANCA   equ (F_BIANCO+F_B_DONNA\
                     +F_B_TORRE+F_B_ALFIERE +(BIT_VALPEZZO*F_VAL_DONNA))
F_TORRE_BIANCA   equ (F_BIANCO+F_B_TORRE    +(BIT_VALPEZZO*F_VAL_TORRE))
F_ALFIERE_BIANCO equ (F_BIANCO+F_B_ALFIERE  +(BIT_VALPEZZO*F_VAL_ALFIERE))
F_CAVALLO_BIANCO equ (F_BIANCO+F_B_CAVALLO  +(BIT_VALPEZZO*F_VAL_CAVALLO))
F_PEDONE_BIANCO  equ (F_BIANCO+F_B_PEDONE   +(BIT_VALPEZZO*F_VAL_PEDONE))
;-------------------------------------------------------------------------------
F_RE_NERO        equ (F_NERO+F_N_RE         +(BIT_VALPEZZO*F_VAL_RE     ))
F_DONNA_NERA     equ (F_NERO+F_N_DONNA\
                     +F_N_TORRE+F_N_ALFIERE +(BIT_VALPEZZO*F_VAL_DONNA  ))
F_TORRE_NERA     equ (F_NERO+F_N_TORRE      +(BIT_VALPEZZO*F_VAL_TORRE  ))
F_ALFIERE_NERO   equ (F_NERO+F_N_ALFIERE    +(BIT_VALPEZZO*F_VAL_ALFIERE))
F_CAVALLO_NERO   equ (F_NERO+F_N_CAVALLO    +(BIT_VALPEZZO*F_VAL_CAVALLO))
F_PEDONE_NERO    equ (F_NERO+F_N_PEDONE     +(BIT_VALPEZZO*F_VAL_PEDONE ))
;-------------------------------------------------------------------------------
F_VUOTA          equ 80000000h
F_VALORE         equ 07FFF0000h
F_ILLEGALE       equ (F_BIANCO+F_NERO)
F_COLORI         equ (F_VUOTA+F_BIANCO+F_NERO)
;-------------------------------------------------------------------------------
; NB: la casa vuota non deve essere = MINIMO senn CercaMigliore non funziona
VUOTA            equ (F_VUOTA + BIT_VALCASA)
ILLEG						 equ F_ILLEGALE
MINIMO           equ 80000000h
MASSIMO          equ 7ffffffeh
VAL_MINIMO       equ (MINIMO+BIT_VALCASA)
;-------------------------------------------------------------------------------
; flag speciale delle mosse
;-------------------------------------------------------------------------------
PROMO_DONNA			 equ 4
PROMO_TORRE			 equ 3
PROMO_ALFIERE		 equ 2
PROMO_CAVALLO		 equ 1
;-------------------------------------------------------------------------------
MAXNODI  equ 64
MAXMOSSE equ (MAXNODI*48)
;-------------------------------------------------------------------------------
CASERIGA  equ 10
S    equ (CASERIGA*size Casa)
N    equ (-S)
N_N  equ (N+N)
S_S  equ (S+S)
E    equ (size Casa)
EE   equ (E+E)
EEE  equ (E+E+E)
W    equ (0-E)
WW   equ (W+W)
WWW  equ (W+W+W)
WWWW equ (W+W+W+W)
NE   equ (N+E)
NW   equ (N+W)
SE   equ (S+E)
SW   equ (S+W)
NNE  equ (N+N+E)
NNW  equ (N+N+W)
SSE  equ (S+S+E)
SSW  equ (S+S+W)
NEE  equ (N+E+E)
NWW  equ (N+W+W)
SEE  equ (S+E+E)
SWW  equ (S+W+W)

